/*
 * SheetReader.java
 *
 * Created on June 10, 2005, 4:53 AM
 */

import java.io.*;
import java.util.*;
import javax.swing.tree.*;

/**
 *
 * @author  MD5 Tag : 2AEDF06823FDAF9405649D893EAB23F5
 */
public class SheetReader
{
    
    String Outpost2Dir;
    ArrayList techList;
    DefaultMutableTreeNode treeTop;
    DefaultMutableTreeNode[] categories;
    
    
    /** Creates a new instance of SheetReader */
    public SheetReader (DefaultMutableTreeNode top)
    {
        techList = new ArrayList();
        treeTop = top;
        categories = new  DefaultMutableTreeNode[13];
        
        categories[0] = new DefaultMutableTreeNode("Non-Tech");
        categories[1] = new DefaultMutableTreeNode("Basic Tech");
        categories[2] = new DefaultMutableTreeNode("Structrial Tech");
        categories[3] = new DefaultMutableTreeNode("Power Tech");
        categories[4] = new DefaultMutableTreeNode("Vehicle Tech");
        categories[5] = new DefaultMutableTreeNode("Food Tech");
        categories[6] = new DefaultMutableTreeNode("Mining Tech");
        categories[7] = new DefaultMutableTreeNode("Weapon Tech");
        categories[8] = new DefaultMutableTreeNode("Space Tech");
        categories[9] = new DefaultMutableTreeNode("Colony Tech");
        categories[10] = new DefaultMutableTreeNode("Planet Tech");
        categories[11] = new DefaultMutableTreeNode("Emergency/Medical Tech");
        categories[12] = new DefaultMutableTreeNode("Space Station Tech");
        
        top.add (categories[0]);
        top.add (categories[1]);
        top.add (categories[2]);
        top.add (categories[3]);
        top.add (categories[4]);
        top.add (categories[5]);
        top.add (categories[6]);
        top.add (categories[7]);
        top.add (categories[8]);
        top.add (categories[9]);
        top.add (categories[1]);
        top.add (categories[11]);
        top.add (categories[12]);

    }
    
    protected void addTech (TechItem d)
    {
        categories[Integer.parseInt (d.getCategory ())].add (new DefaultMutableTreeNode (d));
        techList.add (d);
    }
    
    
    public void buildTechList (File techFile)
    {
        try
        {
            techList.clear ();
            
            Outpost2Dir = techFile.getParent ();
            
            File TeckFile = techFile;
            
            FileReader fr = new FileReader (TeckFile);
            BufferedReader br = new BufferedReader (fr);
            StringTokenizer st = null;
            
            String line = br.readLine ();
            
            while(line !=  null)
            {
                if(line.startsWith ("BEGIN_TECH"))
                {
                    addTech(newTech(line,br));
                }
                line = br.readLine ();
                
            }
            
        }
        catch(IOException e)
        {
            System.out.println (e);
        }
    }
    
    protected TechItem newTech (String starter, BufferedReader source)
    throws IOException
    {
        String temp = "";
        String name = "";
        String iD = "";
        String catagory = "0";
        ArrayList reqs = new ArrayList ();
        String desc = "";
        String teaser = "";
        String eCost = "-1";
        String pCost = "-1";
        String numSci = "0";
        String lab = "1";
        ArrayList actions = new ArrayList ();
        String actionDesc = "";
        
        try
        {
            
            name = starter.substring (12, starter.indexOf ('\"',12));
            iD = starter.substring (10 + name.length ()+4,starter.length ());
            
            temp = source.readLine ();
            while(!temp.startsWith("END_TECH"))
            {
                switch((temp.substring (0,20).hashCode ()))
                {
                    case 1115416318:
                        catagory = temp.substring (20,temp.length ());
                        break;
                    case 2110288324:
                        desc = temp.substring (20,temp.length ());
                        break;
                    case -503075248:
                        teaser = temp.substring (20,temp.length ());
                        break;
                    case 1391684376:
                        actionDesc = temp.substring (21,temp.length ()-1);
                        break;
                    case 281585070:
                        reqs.add (temp.substring (20,temp.length ()));
                        break;
                    case -1157391492:
                        eCost = temp.substring (20,temp.length ());
                        break;
                    case 1521351390:
                        pCost = temp.substring (20,temp.length ());
                        break;
                    case -1162217802:
                        numSci = temp.substring (20,temp.length ());
                        break;
                    case -1703754797:
                        lab = temp.substring (20,temp.length ());
                        break;
                    case 145325133:
                        eCost = temp.substring (20,temp.length ());
                        pCost = temp.substring (20,temp.length ());
                        break;
                    default:
                        actions.add (temp.substring (4,temp.length ()));
                        break;
                }
                
                temp = source.readLine ();
                
            }
        }
        catch(java.lang.StringIndexOutOfBoundsException e)
        {
            System.out.println (name);
            
            System.out.println (temp);
            
            System.out.println (e);
            
            
        }
        
        return new TechItem (name, iD,catagory,reqs, desc, teaser, eCost, pCost, numSci, lab, actions,actionDesc );
    }
    
        public boolean newTech (Object[] lines)
    {
        if(findTech((String)lines[1]) != null)
            return false;
        
        
        String name = (String)lines[0];
        String iD = (String)lines[1];
        String catagory = (String)lines[2];
        ArrayList reqs =(ArrayList)lines[3];
        String desc = (String)lines[4];
        String teaser = (String)lines[5];
        String eCost = (String)lines[6];
        String pCost = (String)lines[7];
        String numSci =(String)lines[8];
        String lab = (String)lines[9];
        ArrayList actions = (ArrayList)lines[10];
        String actionDesc = (String)lines[12];
        
        addTech(new TechItem(name, iD,catagory,reqs, desc, teaser, eCost, pCost, numSci, lab, actions,actionDesc ));
        
        return true;        
    }

    public String getTechList()
    {
        String temp = "";
        Iterator i = techList.iterator ();
        
        while(i.hasNext ())
        {
            temp += ((TechItem)i.next ()).getName () + "\n";
        }
        
        return temp;
    }
    
    public String getScripts()
    {
        String temp = "";
        Iterator i = techList.iterator ();
        
        while(i.hasNext ())
        {
            temp += ((TechItem)i.next ()).getScript () + "\n\n";
        }
        
        return temp;
    }
    
    public TechItem findTech(String id)
    {
        for(int x = 0; x < techList.size(); x++)
        {
            if(((TechItem)techList.get(x)).getID ().equals (id))
                return ((TechItem)techList.get(x));
        }
        return null;
    }
    
    
}

/*
1115416318
2110288324
-503075248
1391684376
281585070
-1157391492
1521351390
-1162217802
-1703754797
-249567966
145325133
-1987257694
-1757240422

 *
 */
